namespace Turbo.Plugins.LightningMod
{
    public class BarbarianGroundStompBandofMightPlugin : AbstractSkillHandler, ISkillHandler
    {
        public BarbarianGroundStompBandofMightPlugin()
            : base(CastType.BuffSkill, CastPhase.AutoCast, CastPhase.UseTpStart, CastPhase.UseWpStart, CastPhase.Move, CastPhase.PreAttack)
        {
            Enabled = true;
        }

        public override void Load(IController hud)
        {
            base.Load(hud);
            AssignedSnoPower = Hud.Sno.SnoPowers.Barbarian_GroundStomp;
            CreateCastRule()
                .IfInTown().ThenNoCastElseContinue()
                .IfCastingIdentify().ThenNoCastElseContinue()
                .IfCastingPortal().ThenNoCastElseContinue()
                .IfOnCooldown().ThenNoCastElseContinue()
                .IfCanCastBuff().ThenContinueElseNoCast()
                .IfCanCastSimple().ThenContinueElseNoCast()
                .IfTrue(ctx => ctx.Hud.Game.Me.Powers.BuffIsActive(hud.Sno.SnoPowers.BandOfMight.Sno, 0)).ThenContinueElseNoCast()
                .IfEnoughMonstersNearby(ctx=> 70, ctx=>1).ThenContinueElseNoCast()
                .IfSpecificBuffIsAboutToExpire(hud.Sno.SnoPowers.BandOfMight, 1 , 50 , 300).ThenCastElseContinue()
                ;
        }
    }
}